import type { CodeBuilderOptions } from '@readme/httpsnippet/dist/helpers/code-builder';
import { CodeBuilder as HTTPSnippetCodeBuilder } from '@readme/httpsnippet/dist/helpers/code-builder';
export type { CodeBuilderOptions };
export declare class CodeBuilder extends HTTPSnippetCodeBuilder {
    sections: {
        payload?: {
            start: number;
            end: number;
        };
        verification?: {
            start: number;
            end: number;
        };
    };
    variables: {
        security?: Record<string, {
            line: number;
        }>;
        server?: Record<string, {
            line: number;
        }>;
    };
    startSection: (section: 'payload' | 'verification') => void;
    endSection: (section: 'payload' | 'verification') => void;
    ranges: () => {
        sections: {
            payload?: {
                start: number;
                end: number;
            };
            verification?: {
                start: number;
                end: number;
            };
        };
        variables: {
            security?: Record<string, {
                line: number;
            }>;
            server?: Record<string, {
                line: number;
            }>;
        };
    };
    /**
     * Push a dynamic piece of code to the snippet and record where in the snippet it was added.
     *
     */
    pushVariable: (line: string, opts: {
        name: string;
        indentationLevel?: number;
        type: 'security' | 'server';
    }) => void;
}
