"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
exports.__esModule = true;
exports.MetricsSDKSnippet = exports.extname = exports.availableWebhookTargets = exports.availableServerTargets = void 0;
var targets_1 = require("./targets/targets");
var utils_1 = require("./helpers/utils");
__createBinding(exports, utils_1, "availableServerTargets");
__createBinding(exports, utils_1, "availableWebhookTargets");
__createBinding(exports, utils_1, "extname");
var MetricsSDKSnippet = /** @class */ (function () {
    function MetricsSDKSnippet(input, data) {
        if (data === void 0) { data = {}; }
        var _this = this;
        var _a;
        this.variables = [];
        this.convert = function (snippetType, targetId, clientId, options) {
            if (!options && clientId) {
                // eslint-disable-next-line no-param-reassign
                options = clientId;
            }
            var target = targets_1.targets[targetId];
            if (!target || !target.services.webhooks) {
                return false;
            }
            var convert = target.services[snippetType][clientId || target.info["default"]].convert;
            // Reduce our variables into a set keyed by their type.
            var _a = _this.variables.reduce(function (prev, next) {
                prev[next.source].push(next);
                return prev;
            }, { server: [], security: [] }), server = _a.server, security = _a.security;
            return convert({ secret: _this.secret, server: server, security: security }, options);
        };
        this.variables = input;
        this.secret = (_a = data.secret) !== null && _a !== void 0 ? _a : 'my-readme-secret';
    }
    return MetricsSDKSnippet;
}());
exports.MetricsSDKSnippet = MetricsSDKSnippet;
